#include "analyseur.h"

int tailletab=0;
int err_j=0;

int menu(){

int x=0;
do{

cout<<"1. Lire un fichier existant."<<endl<<
 	"2. Ecrire un programme en ligne de commande et le sauvegarder."<<endl<<
    "3. afficher l'aide."<<endl<<
    "4. quitter le programme."<< endl;
	cin>>x;
}while (x<1 || x >4);

return x;
}

chaine saisie(){
chaine fich="",ch="", commande;
cout << "entrer le nom de votre fichier (ATTENTION : si un fichier porte le meme nom, il sera ECRASE !)"<< endl;
cin >> fich;


chaine line;
vector<string> text;
cout<<"Entrez votre texte. Ctrl+D en debut de ligne puis entree pour finir (les retours a la ligne sont possibles)"<<endl;
bool ok=true;
	
while(ok && getline(cin,line) ) {
    if (line[longueur(line)-1] == 0x04) ok=false;
    else text.push_back(line);
}
//recupere le texte tape dans la variable text

for(int i=1;i<text.size();i++){
	if(i==1)ch=ch+text[i];
	else ch=ch+"\n"+text[i];
}
//on met le rexte tape dans une chaine.


ofstream fichier(fich.c_str(), ios::out|ios::trunc);
if (fichier)
{
fichier << ch << endl;
}
//place le texte dans le fichier si le fichier est ouvert.

fichier.close();

return fich;
}

bool EstProgramme(tab t, chaine & probleme)
{
    int i=0,j=0, ferme;
    bool ok=false;
	chaine t_j;

    i=EstListeDef(t,i);
		j++;
		if(t[i]=="{"){
			i++;
			j++;

			ferme=recherche_fermante("{","}", t, i);

			if(ferme != -1){
				j=ferme-1;

				if ( (EstListeInstruction(t,i,j) && (j+2)==tailletab) ){
	//On verifie que c'est une instruction entre les deux {} et qu'il n'y a rien ensuite

					ok=true;
				}
				else{}
			}
		}

if(!ok)	{
	char j_err=(char)err_j+48;
	
	probleme = "Probleme au lexeme numero "+j_err;


}

return ok;
}



int EstListeDef(tab t, int i)
{

int k=i;
if(!EstDef(t,i,k)){ return i ;}
else return EstListeDef(t,k);

}


bool EstDef(tab t, int i, int & j){
bool ok = false;
int ferme=-1;

	if(t[i] == "Def"){
		i++;
		if(EstNomDeFonction(t, i)){
			i++;
			if(t[i]=="("){
				i++;
				ferme=recherche_fermante("(", ")", t, i);
				if (ferme != -1){
					j=ferme-1;
					if (EstListeParamFormel(t, i, j)){
						j=ferme+1;
						i=j;
						if(t[i]=="{"){
							i++;
							ferme=recherche_fermante("{", "}", t, i);
								if(ferme !=-1){
									j=ferme-1;
									if (EstListeInstruction(t, i, j)){
										j=ferme+1;
										ok=true;
									}
								}
							}
						}
					}
				}
			}
		}
	
	if(!ok) {j=err_j; cout<<"j_der="<<err_j<<endl;}
	return ok;
}




bool EstListeInstruction(tab t, int i, int j)
{

	bool ok=true;
	int k=i, l=i;

	if (i>j)return ok;

	while ( l<=j && ok && l<tailletab){

	     if(!EstInstruction(t,l,k))
            {	err_j = k;
                ok=false;
            }
            else
            {
		
                l=k;
            }

	}
	j=l+1;

	return ok;

}


bool EstListeParamFormel(tab t, int i, int j)
{
    bool ok=true;

	for(i; i<j && ok;i++) {
		if(!EstParamFormel(t,i)) { ok=false; err_j=i;}
	}

	return ok;
}


bool EstParamFormel(tab t, int i)
{
    return EstIdentificateur(t[i]);
}


bool EstNomDeFonction(tab t, int i)
{
    return EstIdentificateur(t[i]);
}



bool EstInstruction(tab t, int i, int & j)
{
	return (EstOrdreSimple(t,i,j) || EstConditionnelle(t,i,j) || EstRep(t,i,j) || EstAppel(t,i,j) );						
}




bool EstConditionnelle(tab t, int i, int & j)
{
	bool ok = false;
	int acc;

	if (t[i] == "Si")
	{

		i++;
		j=i;
		if (t[i] == "(")
		{
			i++;

			acc=recherche_fermante("(", ")", t, i);
            if (acc != -1)
			{

				if (EstComparaison(t, i, j))
				{
					j++;
					i=j;
					if (t[i] == "{")
					{
						i++;

						acc=recherche_fermante("{", "}", t, i);
						if (acc != -1)
						{
							if (EstListeInstruction(t, i, acc-1 ))
							{
								      i=acc+1;
								if (t[i] == "{")
								{
									i++;
									acc=recherche_fermante("{", "}", t, i);
									if (acc != -1)
									{
										j=acc-1;
										if (EstListeInstruction(t, i, j))
										{
											j=acc+1;
											ok = true;
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}

	return ok;
}



bool EstComparaison(tab t, int i, int &j)
{
	bool ok=false;

	if(EstExpression(t, i, j) )
	{
	    i=j;


	    if(EstOpComparaison(t[i]))
	    {
	        i=i+1;
	        if(EstExpression(t, i,j))
	        {
	            ok=true;
	        }
	    }
	}

return ok;
}



bool EstRep(tab t, int i, int & j)
{

	bool ok = false;
	int acc;

	if (t[i] == "Rep")
	{

		i++;
		j=i;
		if (EstExpression(t, i, j))
		{
		i=j;
			if (t[i] == "{")
			{
				i++;
				acc=recherche_fermante("{", "}", t, i);
            			   if (acc != -1)
				{
				   if (EstListeInstruction(t, i, acc-1 ))
					{
					ok = true;
					j=acc+1;
               				}
            			}
			}
		}
	}
	return ok;
}


bool EstAppel(tab t, int i, int &j )
{
	bool ok=false;
    j=i;
	if(EstIdentificateur(t[i]))
	{
		i++;
		j++;
		if(t[i]=="(")
			{
			     j=recherche_fermante("(", ")", t, i+1);
			if (j != -1){
			ok= EstListeParamEffectif(t, i+3,j-1);
}


	}

}
j++;
		return ok;
}



bool EstListeParamEffectif(tab t, int i, int j)
{
	bool ok=true;
	int k=i;
	for(i;i<j && ok;i++)
	{
	    if(!EstExpression(t,i,k))ok=false; // si les element de i a j sont des expression on renvoi true;
	    i=k;
	}
	return ok;
}


bool EstOrdre(chaine ch)
{
    return (EstOrdreSimple0(ch)||EstOrdreSimple1(ch)||EstOrdreSimple2(ch));
}


bool EstOrdreSimple(tab t, int i , int &j)
{
	return EstOrdreSimple0(t,i,j)||EstOrdreSimple1(t,i,j)||EstOrdreSimple2(t,i,j);
}



bool EstOrdreSimple0(chaine ch)
{
    return (ch=="Lp")||(ch=="Bp")||(ch=="Ve")||(ch=="Mo")||(ch=="Ca");
}

bool EstOrdreSimple1(chaine ch)
{
    return (ch=="Av")||(ch=="Re")||(ch=="Td")||(ch=="Tg")||(ch=="Cp")||(ch=="Fa")||(ch=="Cf");
}

bool EstOrdreSimple2(chaine ch)
{
    return (ch=="Aller");
}


bool EstOrdreSimple0(tab t, int i , int &j)
{
	chaine ch=t[i];
	bool ok = ((ch=="Lp")||(ch=="Bp")||(ch=="Ve")||(ch=="Mo")||(ch=="Ca"));
	j++;
	return ok;
}

bool EstOrdreSimple1(tab t, int i , int &j)
{
	bool ok=false;
	chaine ch=t[i];
	if ((ch=="Av")||(ch=="Re")||(ch=="Td")||(ch=="Tg")||(ch=="Cp")||(ch=="Fa")||(ch=="Cf"))
	{
	i++;
		if(EstExpression(t,i,j))
		{

			ok=true;
		}
	}

return ok;
}


bool EstOrdreSimple2(tab t, int i , int &j)
{
	bool ok=false;
	chaine ch=t[i];
	if((ch=="Aller"))
		{
			i++;
			if( EstExpression(t, i, j))
			{
				if(( EstExpression(t, j, j)) && j < tailletab)
            			{
                			ok=true;
            			}
			}

		}
            return ok;

}



bool EstExpression(tab t ,int i, int & j)
{
    bool ok=false;
j=i;
if (t[i]=="")return false;

   if(EstNombre(t[i]))
   {
        ok=true;
        j++;
   }
   else if(EstObservateur(t[i]))
       {
           ok=true;
          j++;
       }
       else if(EstExpArith(t,i,j))
            {
                i=j;
                ok=true;

            }
            else if( EstIdentificateur(t[i]))
                {
                    ok=true;
                    j++;
                }
   return ok;
}


bool EstExpArith(tab t, int i, int &j) {
    bool ok=false;


    if(EstOperateur(premier(t[i])))
    {
        i++;
        j++;

            if(EstExpression(t,i,j))
            {
            i=j;
                    if (EstExpression(t,i,j))
                    {
                        ok= true;
                        i=j;

                    }
            }
    }
    return ok;
}


bool EstObservateur(chaine ch)
{
    return (ch=="?x")||(ch=="?y")||(ch=="?l")||(ch=="?a")||(ch=="?v")||(ch=="?cf")||(ch=="?cp");
}



bool EstNombre(chaine ch)
{
    return ( EstReel(ch) || EstEntier(ch));
}


bool EstEntier(chaine ch)
{
    bool ok=0;
    if((longueur(ch)==1) && (premier(ch)=='0')) ok=1;
    if((longueur(ch)==1) && (EstChpos((int)premier(ch)-48))) ok=1;
    if((longueur(ch)>1) && (EstChpos((int)premier(ch)-48)) && (EstSuiteCh(reste(ch)))) ok=1;
    return ok;
}

bool EstReel(chaine ch)
{
    bool ok=true;
    bool virgule=0;
    int j=longueur(ch);
    chaine ch1="";

    for(int i=0;i<j && ok;i++)
    {

            if((premier(ch)=='.') && !virgule)
                {
                virgule=1;
                ok=EstEntier(ch1);
                ch1="";
                ch=reste(ch);
                }
            else if(premier(ch)=='.' && virgule)
                {
                     ok=false;
                }
                else
                {


        ch1=ch1+premier(ch);
                ch = reste(ch);
                }
    }
    if(ch=="" && virgule)
	{
		ok=ok && EstSuiteCh(ch1);
	}
	if(!virgule) ok=false;
    return ok;
}

bool EstChpos(int n)
{
    return (n<=9)&&(n>0);
}

bool EstSuiteCh(chaine ch)
{
    bool ok=true;

    for(int i=0; ch!="" && ok ;i++)
    {
        if( !EstChpos((int)premier(ch)-48) && !((int)premier(ch)-48==0) )  ok=false;
 // si on trouve qqch qui nest pas un O ou une suite de chiffre positif on retourne false;
        ch=reste(ch);
    }
    return ok;
}


bool EstSymbole (chaine ch)
{
    return (ch=="{")||(ch=="}")||(ch=="(")||(ch==")");
}

bool EstMotClef(chaine ch)
{
	return (ch=="Rep")||(ch=="Def")||(ch=="Si");
}

bool EstOperateur(char c)
{
    bool ok=0;
    switch(c)
    {
        case '+': ok=1; break;
        case '-': ok=1; break;
        case '*': ok=1; break;
        case '/': ok=1; break;
    }
    return ok;
}


bool EstOpComparaison(chaine ch)
{
    return (ch=="<")||(ch==">")||(ch=="=")||(ch==">=")||(ch=="<=")||(ch=="!=");
}



bool EstIdentificateur(chaine ch)
{
    bool ok=1;
	if(!EstObservateur(ch) && !EstOpComparaison(ch) && !EstOrdre(ch) && !EstMotClef(ch)){
	while(ch!="" && ok){
         if(!EstLettre(premier(ch))) ok=0; // si on a qqch qui n'est pas une lettre on retourne false;
         ch=reste(ch);
    }

    return ok;
}
else return false;
}


bool EstLettre(char c)
{
    return (c>='a' && c<='z')||(c>='A' && c<='Z');
}


chaine transcripte(chaine ch, tab t, tab t_fct, tab t_var)
{
	int i=0,j=0,k=0;
	chaine retour="";
	chaine ch1="";
	bool erreur=false;
	while(ch!="" && !erreur)
	{
		if(premier(ch)==' '&& ch1!="")
		{
// si le mot trouve est un identificateur on le stock dans t[i]
if(EstNombre(ch1)) { t[i]= ch1;} // idem ....
	else if(ch1=="Si"){ t[i]=ch1;}// proposition de mettre les lettres dans une autre tab que celui des lexemes
		else if(EstSymbole(ch1)){ t[i]=ch1;}
			else if(ch1=="Def"){ t[i]=ch1;}
				else if(ch1=="Rep"){t[i]=ch1;}
					else if(EstOrdreSimple0(ch1)){t[i]=ch1;}
					else if(EstOrdreSimple1(ch1)){t[i]=ch1;}
					else if(EstOrdreSimple2(ch1)){t[i]=ch1;}
						else if( EstObservateur(ch1)){t[i]=ch1;}
							/*else if( EstAffectation2(ch1)){t[i]=ch1;}*/
								else if(EstOperateur(premier(ch1))){t[i]=ch1;}
									else if(EstOpComparaison(ch1)){t[i]=ch1;}
										else if(EstIdentificateur(ch1)){t[i]=ch1;
                                             if (t[i-1] == "Def"){ t_fct[j]=ch1;
                                                           j++;
                                                         }
                                             else
                                             {
                                             t_var[k]=ch1;
                                             k++;
                                             }
                                                           			 }
                                        				else if(ch1!="")
                                                            {
                                                                erreur=true;
                                                                retour="erreur au mot "+ ch1+" partir de : "+ch1+ch;
                                                            }
								else if (i>=5000){
								erreur = true;
								retour="programme trop long (5000 mots max)";
								}
			i++;
			ch1="";
		}
		else if(premier(ch)!=' ')	ch1=ch1+ premier(ch);
		ch=reste(ch);

	}

	tailletab=i;

	return retour;
}



chaine ajout_espaces(chaine ch){
	chaine espace=" ";
	char c=premier(ch), p='a';

ch=reste(ch);

	for (int i = 0; !vide(ch); i++){

		if ((p =='>')||(p=='<')||(p=='!')){
			if((c =='=')){
				espace = espace+c+" ";
			}else espace = espace+" "+c;
		}

		else if ((c =='>')||(c=='<')||(c=='!')) {
			espace = espace+" "+c;
		}
		else if (c=='='){
			espace = espace+" "+c+" ";
		}
			else if (c=='{' || c=='}' || c=='(' || c==')' || c=='*' || c=='+' || c=='/'  || c=='-'){
				espace=espace+" "+c+" ";
			}
			else if ( c=='\t' || c=='\b' || c=='\n' || c=='\r' || c=='\f'|| c=='\0' ){
				espace=espace+" ";
			}
			else {
				espace = espace+c;
			}

		p=c;
		c=premier(ch);
		ch=reste(ch);
		}

	espace=espace+" ";

	return espace;
}



int recherche_fermante(chaine ch, chaine cherchee, tab t, int i){
	bool ok = false;
	int cpt = 1;

	while(!ok && i<tailletab){
		if (t[i]==ch)cpt++;
		if (t[i]==cherchee)cpt--;
		if (cpt == 0)ok = true;
			else i++;

	}

	if (!ok) i=-1;

	return i;


}


/*
bool EstAffectation2(chaine ch)
{
    return (ch==":=");
}
*/


/*
bool EstAffectation(tab t, int i, int &j)
{

    if(EstIdentificateur(t[i]))
    {
	i++;
        if(EstAffectation2(t[i]))
            {
		i++;
		j=i;
                if(EstExpression(t,i,j))
                {
                    return true;
                }
            }
    }
    return false;
}*/



