#ifndef _ANALYSEUR
#define _ANALYSEUR
#include "chaine.h"
typedef chaine tab[500];



inline void help(){
cout<<"utilisation:"<< endl <<
        "usage linux: \"./analyseur nom_de_fichier\" ou \"./analyseur\" "<<endl <<
        "usage windows: .\\analyseur.exe nom_de_fichier\" ou \".\\analyseur.exe\" "<<endl<< endl<<
        "pour avoir la documentation tapez ./analyseur -doc ou .\\analyseur.exe -doc"<<endl;
}
/*Fonction d'aide*/

inline bool existe(const char * ch){
  return fopen(ch,"r");
}


inline void doc(){
chaine doc;
  lire_fichier2("doc.txt", doc);
cout<<doc<<endl;
}

chaine saisie();
int menu();

bool EstProgramme(tab, chaine & );
/*retourne vrai si le tableau contient un programme tortue, et modifie egalement*/

/*
Toutes les fonctions bool renvoient vrai si le contenu du tableau, de la chaine ou du caractere etudie est ce qu'attend la fonction
(cf le nom de la fonction). EstListeInstruction recherche une liste d'instructions entre deux indices (-> deux accolades), et les autres fonctions dont le second indice est pass par rfrence mettent  jour celui ci pour indiquer le dernier lexme correct.
*/

int EstListeDef(tab, int );
/*retourne l'indice de la derniere liste de definition correcte*/
bool EstListeInstruction(tab, int, int);

bool EstDef(tab , int, int &);
bool EstListeParamFormel(tab , int, int);
bool EstParamFormel(tab , int);
bool EstNomDeFonction(tab , int);

bool EstInstruction(tab , int, int &);
bool EstConditionnelle(tab , int, int &);
bool EstComparaison(tab , int, int &);
bool EstRep(tab , int, int &);
bool EstAppel(tab , int, int &);

bool EstListeParamEffectif(tab , int, int);

bool EstOrdre(chaine);
bool EstOrdreSimple(tab , int, int &);
bool EstOrdreSimple0(chaine );
bool EstOrdreSimple0(tab , int , int &);
bool EstOrdreSimple1(chaine );
bool EstOrdreSimple1(tab , int , int &);
bool EstOrdreSimple2(chaine );
bool EstOrdreSimple2(tab , int , int &);

bool EstExpression(tab, int, int & );
bool EstExpArith(tab , int , int &);
bool EstObservateur(chaine );


bool EstNombre(chaine );
bool EstEntier(chaine );
bool EstReel(chaine );
bool EstChpos(int);
bool EstSuiteCh(chaine );
bool EstSymbole (chaine );
bool EstMotClef (chaine); /*retourne vrai si la chaine etudiee est un mot reserve du langage tortue ( "Def", "Si" ou "Rep" )*/

bool EstOperateur(char);
bool EstOpComparaison(chaine );

bool EstIdentificateur(chaine );
bool EstLettre(char);

chaine transcripte(chaine, tab , tab , tab );//
/*Fonction qui trie chaque lexeme, et separe les identificateurs de variables et de fonction dans deux autres tableaux*/

chaine ajout_espaces(chaine);
/* ajoute automatiquement des espaces aux parentheses et accolades, et remplace les caracteres speciaux (tabulation, retour a la ligne, etc.) par des espaces.*/

int recherche_fermante(chaine , chaine , tab , int );
/*retourne l'indice de la parentese/de l'accolade fermante correspondant a celle se trouvant a l'indice passe en parametre.
Retourne -1 s'il n'y en a pas (erreur dans le nombre de parentheses)*/

#endif
